#include <stdio.h>
#include <stdlib.h>

typedef long long ll;

int main(){
    int N,Q,i,j,s;
    scanf("%d %d",&N,&Q);

    ll d[N],k[Q];
    int p[N];
    
    for(i=0;i<N;i++){
        scanf("%lld %lld",&d[i],&p[i]);
    }
    
    for(i=0;i<Q;i++){
        scanf("%lld",&k[i]);
    }
    
    ll ima,ukup;
    
    for(i=0;i<Q;i++){
    	s=0;
    	ima=0;
    	ukup=0;
    	
        for(j=1;j<=k[i];j++){
        	
        	if(d[s]==j){
        		ima+=p[s];
        		s++;
			}
			
            if(ima>0){
                ima--;
                ukup++;
            }
        }
        
        printf("%lld\n",ukup);
    }
    
    return 0;
}